//////////////////////////////////
//  ƓxL^vU  i2func.c      //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

//////// I2C
//       CNbN4MHz:@{[[g100KHz
// SSPADD = X , 0.1 = 4/(4 * (X + 1)) , X = 9
void I2init(void){
    SSPCON1 = 0x8;          //}X^[[h
    SSPCON2 = 0;            //Zbg
    SSPSTAT = 0;
    SSPADD = 9;             //{[[g100KHz
    SSPCON1bits.SSPEN = 1;  //MSSPgp
    IPR1bits.SSPIP = 1;     //MSSP荞݂ʃx
    PIE1bits.SSPIE = 1;     //MSSP荞݋
    IntI2c = 0;
}

//////// X^[gRfBV
void I2startCon(void){
    SSPCON2bits.SEN = 1;    //X^[g
    while(IntI2c == 0);     //I҂
    IntI2c = 0;             //荞݃tONA
}

//////// X^[gRfBVđ
void I2startRep(void){
    SSPCON2bits.RSEN = 1;   //ăX^[g
    while(IntI2c == 0);     //I҂
    IntI2c = 0;             //荞݃tONA
}

//////// PoCgM
// FMf[^@߂l 0:ACK,1:NACK
uchar I2write(uchar data){
    while(SSPSTATbits.BF);      //BUSY
    SSPBUF = data;              //f[^M
    while(IntI2c == 0);         //M҂
    IntI2c = 0;                 //荞݃tONA
    return SSPCON2bits.ACKSTAT;
}

//////// PoCgM
// @0:ACKԂA1:NACKԂ
// ߂l@Mf[^
uchar I2read(uchar ACK){
    uchar tmp;    

    SSPCON2bits.ACKDT = ACK;
    SSPCON2bits.RCEN = 1;       //M
    while(IntI2c == 0);         //M҂
    tmp = SSPBUF;               //ǂݎ
    IntI2c = 0;                 //荞݃tONA
    SSPCON2bits.ACKEN = 1;      //ACKDTM
    while(IntI2c == 0);         //ACKM҂
    IntI2c = 0;                 //荞݃tONA@@
    return tmp;
}

//////// XgbvV[PX
void I2stop(void){
    SSPCON2bits.PEN = 1;    //Xgbvo
    while(IntI2c == 0);     //I҂
    IntI2c = 0;             //荞݃tONA
}
