//////////////////////////////////
//  ƓxL^vU  interrupt.c   //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

volatile uchar cnt_DOWN;                //̓`b^JE^
volatile uchar cnt_UP;
volatile uchar cnt_ENT;
volatile uchar cnt_MODE;
INSWBITS INSWbits = {0,0,0,0,0,0,0,0};  //͂rvrbg\
volatile uchar IntI2c;                  //hQb荞݃tÕRs[
volatile char rxd[10];                  //RS232CMR}hobt@
volatile uchar rxp;                     //M|C^
volatile uchar RXEND;                   //MtO

#pragma interrupt isr
#pragma code isrcode = 0x8

void jump_isr(void){            //荞݊֐փWviO͉łǂj
    _asm
    goto isr
    _endasm
}

#pragma code
void isr(void){                 //荞݊֐iO͉łǂj
    char c;

    if (PIR1bits.CCP1IF){       //bboP荞ݗv
        PIR1bits.CCP1IF = 0;    //荞݃tONA
        tics++;
    }
    if(INTCONbits.INT0IF){      //INT0荞
        INTCONbits.INT0IF = 0;
    }
    if (PIR1bits.TMR2IF){                   //^C}[2荞
        PIR1bits.TMR2IF =0;                 //荞݃tONA
        if (!PORTCbits.RC5){                //DOWN t
            if (cnt_DOWN < 255) cnt_DOWN++;
            if(cnt_DOWN > 4) DOWN = 1;
            if(cnt_DOWN > 100) DOWN_L = 1;
        }
        else {
            cnt_DOWN = 0;
            DOWN = 0;
            DOWN_L = 0;
        }
        if (!PORTCbits.RC2){                //UP t
            if (cnt_UP < 255) cnt_UP++;
            if (cnt_UP > 4) UP = 1;
            if (cnt_UP > 100) UP_L = 1;
        }
        else {
            cnt_UP = 0;
            UP = 0;
            UP_L = 0;
        }
        if (!PORTCbits.RC1){                //ENT t
            if (cnt_ENT < 255) cnt_ENT++;
            if (cnt_ENT > 4) ENT = 1;
            if (cnt_ENT > 100) ENT_L = 1;
        }
        else {
            cnt_ENT = 0;
            ENT = 0;
            ENT_L = 0;
        }
        if (!PORTCbits.RC0){                //MODE t
            if (cnt_MODE < 255) cnt_MODE++;
           if (cnt_MODE > 4) MODE = 1;
            if (cnt_MODE > 100) MODE_L = 1;
        }
        else {
           cnt_MODE = 0;
           MODE = 0;
           MODE_L = 0;
        }
    }
    if(PIR1bits.SSPIF){             //I2C荞
        PIR1bits.SSPIF =0;
        IntI2c = 1;
    }
    if(PIR1bits.RCIF){              //RS232CM荞
        c = RCREG;                  //荞݃tO̓NA
        if(! RXEND){
            rxd[rxp] = c;           //MWX^̓eobt@ɓǂݎ
            if(rxd[rxp] == '\r'){   //IR[h
                RXEND = 1;          //M
            }
            rxp++;                  //|C^i߂
            if(rxp > 10) rxp = 0;   //őM
        }
    }
}
