////////////////////////////////////////////
//   LCDLIB4S.C (SC1602,2004  4BIT BUS)   //
//   2015/01/23  C18                      //
////////////////////////////////////////////
//w|[gBIT1`BIT4ɏo
//sATC global.h ɋLq

#include "global.h"

//////// P\
void lcd_data(char asci){                               //asci: ݃f[^
    lcd_rs = 1;                                         //f[^̏  
    lcd_port = (asci >> 3 & 0x1e) | (lcd_port & 0xe1);  //f[^ʁic|[gۑj
    Delay1TCY();                                        //NOP
    lcd_stb = 1;                                        //Xg[uグ;
    Delay1TCY();                                        //NOP
    Delay1TCY();                                        //NOP
    lcd_stb = 0;                                        //Xg[u̗
    lcd_port = (asci << 1 & 0x1e) | (lcd_port & 0xe1);  //f[^ʁic|[gۑj
    Delay1TCY();                                        //NOP
    lcd_stb = 1;                                        //Xg[uグ
    Delay1TCY();                                        //NOP
    Delay1TCY();                                        //NOP
    lcd_stb = 0;                                        //Xg[u̗
    Delay10TCYx(CONFIG_MHZ);                            //40uS
}

//////// R}h̏
void lcd_cmd(char cmd){                                 //cmd: R}h
    lcd_rs = 0;                                         //R}h̏    
    lcd_port = (cmd >> 3 & 0x1e) | (lcd_port & 0xe1);   //f[^ʁic|[gۑj
    Delay1TCY();                                        //NOP
    lcd_stb = 1;                                        //Xg[uグ;
    Delay1TCY();                                        //NOP
    Delay1TCY();                                        //NOP
    lcd_stb = 0;                                        //Xg[u̗
    lcd_port = (cmd << 1 & 0x1e) | (lcd_port & 0xe1);   //f[^ʁic|[gۑj
    Delay1TCY();                                        //NOP
    lcd_stb = 1;                                        //Xg[uグ
    Delay1TCY();                                        //NOP
    Delay1TCY();                                        //NOP
    lcd_stb = 0;                                        //Xg[u̗
    Delay10TCYx(CONFIG_MHZ);                            //40uS
}

//////// S֐
void lcd_clear(void){
    lcd_cmd(0x01);                  //R}ho
    Delay100TCYx(CONFIG_MHZ*5);     //2mS
}

//////// o͊֐iq`l̈j
void lcd_str(char *str){
    while(*str != 0x00)             //̏I蔻
    {
        lcd_data(*str);             //Po
        str++;                      //|C^{P
    }
}

//////// o͊֐iqnl̈j
void lcd_str_rom(rom const char *stc){
    while(*stc != 0x00)             //̏I蔻
    {
        lcd_data(*stc);             //Po
        stc++;                      //|C^{P
    }
}

//////// R}h̏
void lcd_incmd(char cmd){                               //cmd: R}h
    lcd_rs = 0;                                         //R}h̏    
    lcd_port = (cmd >> 3 & 0x1e) | (lcd_port & 0xe1);   //R}hic|[gۑj
    Delay1TCY();                                        //NOP
    lcd_stb = 1;                                        //Xg[uグ
    Delay1TCY();                                        //NOP
    Delay1TCY();                                        //NOP
    lcd_stb = 0;                                        //Xg[u̗
    Delay100TCYx(CONFIG_MHZ*13);                        //5.2mS
}

//////// 
void lcd_init(){
    Delay1KTCYx(CONFIG_MHZ * 4);    //16mS
    lcd_incmd(0x30);                //8bit mode set
    lcd_incmd(0x30);                //8bit mode set
    lcd_incmd(0x30);                //8bit mode set
    lcd_incmd(0x20);                //4bit mode set
    lcd_cmd(0x28);                  //DL=0 4bit mode,5x7dot
    lcd_cmd(0x0c);                  //display on C=D=1 B=0
    lcd_cmd(0x06);                  //entry I/D=1 S=0
    lcd_cmd(0x1);                   //clear
}
