//////////////////////////////////
//  ƓxL^vU  main.c        //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

uchar job_no;   //Ƃ̎
uchar poff_cnt; //dItpJE^

//////// delay֐(1`48MHz)
void delay_ms(uint num){
    uint i;

    for(i = 0; i < num; i++){
        Delay100TCYx(CONFIG_MHZ*2);
        Delay10TCYx(CONFIG_MHZ*5);
    }
}

//////// ^C}[Qi̓`b^j
void inp_init(void){
    T2CON = 0x7d;               //^C}[2gpApri1/4,post1/16
    IPR1bits.TMR2IP = 1;        //ʃxɂĂ
    PIE1bits.TMR2IE = 1;        //^C}[2荞݋
    cnt_DOWN =0;
    cnt_UP = 0;
    cnt_ENT = 0;
    cnt_MODE = 0;
}

//////// dIt
void power_off(void){
    lcd_clear();
    while(ENT);
    LATAbits.LATA7 = 0;
}

//////// Ɩ\
void    job_name(void){
    lcd_cmd(0xc0);
    switch(job_no){
        case    0:  lcd_str_rom("ˮ ");   break;
        case    1:  lcd_str_rom("  ");   break;
        case    2:  lcd_str_rom("޼ ");   break;
        case    3:  lcd_str_rom("H ");   break;
        case    4:  lcd_str_rom("D ");   break;
        case    5:  lcd_str_rom(" ");   break;
        case    6:  lcd_str_rom("Ĺ   ");   break;
        case    7:  lcd_str_rom("خ");   break;
        default:    break;
    }
}

//////// 상j[
void    menu_sel(void){
    lcd_clear();
    timer_start(TIMER_MAIN_OFF, 60000);
    while(1){
            lcd_cmd(0x80);
            lcd_str_rom("Ӹ  <-  ->");
            job_name();                     //Ɩ\
        if(DOWN){                           //downL[ꂽ
            if(job_no > 0) job_no--;
            else    job_no = 7;
            job_name();                     //Ɩ\
            delay_ms(800);                  //ODWbXL
        }
        if(UP){                             //UPL[ꂽ
            job_no++;
            if(job_no > 7) job_no = 0;
            job_name();                     //Ɩ\
            delay_ms(800);                  //ODWbXL
        }
        if(ENT_L){                          //݃L[
            switch(job_no){
                case    0:  measure();      break;      //\
                case    1:  sampling();     break;      //v
                case    2:  data_read();    break;      //f[^ǂݏo
                case    3:  commun(1);      break;      //f[^MiHexj
                case    4:  commun(0);      break;      //f[^Milj
                case    5:  removal();      break;      //
                case    6:  time_set();     break;      //v̐ݒ
                case    7:  power_off();    break;      //dIt
                default:    break;
            }
            lcd_clear();
            while(MODE || ENT || DOWN || UP);
        }
        if(timer_check_start(TIMER_MAIN_OFF)) poff_cnt++;
        if(MODE || ENT || DOWN || UP) poff_cnt = 0;
        if(poff_cnt > 10)  LATAbits.LATA7 = 0;          //dIt
        if(MODE_L) LATAbits.LATA7 = 0;                  //dIt
    }
}

//////// C֐
void    main(void){

    OSCCON = 0x62;          //4MHz
    ad_init();              //A/D
    TRISA = 0x4f;           //|[gAo͐ݒ
    LATAbits.LATA7 = 1;     //dȕێ
    LATAbits.LATA4 = 1;     //qrdIt;
    TRISB = 0xc1;           //|[gBo͐ݒ
    TRISC = 0xff;           //|[gCo͐ݒ
    RCONbits.IPEN = 0;      //荞ݗD惌xgȂ
    INTCONbits.PEIE = 1;    //ӊ荞݂
    INTCONbits.GIE = 1;     //S荞݂
    lcd_init();             //t\
    inp_init();             //̓^C}[
    timer_init();           //\tgEGA^C}[
    I2init();               //I2Cݒ
    tim_init();             //v̏ݒ
    delay_ms(100);
    vlchk();                //vobNAbṽ`FbN
    job_no = 0;
    lcd_clear();
    while(1){                       //dSW=OFF̊mF
        if(!PORTAbits.RA6) continue;
        Delay10KTCYx(CONFIG_MHZ);   //40mS
        if(PORTAbits.RA6) break;
        Delay10KTCYx(CONFIG_MHZ);   //40mS
    }
    poff_cnt = 0;
    menu_sel();                     //상j[
    LATAbits.LATA7 = 0;             //dIt
    while(1);
}
