//////////////////////////////////
//  ƓxL^vU  adconv.c      //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

ADDATA addata;
uint ad_result[3];          //ADʂۑ

//////// A/D
void ad_init(void){
    ADCON1 = 0x1b;          //AN0-3 = ANALOG, AN3 = VREFF+
    ADCON2 = 0x94;          //El߁A4Tad,Fosc/4
}

//////// A/Dϊ
//       @A/D CH (0 - 2)
int ad_conv(uchar ch){
    ADCON0 = ch << 2;       //ch set
    ADCON0bits.ADON = 1;    //A/Dgp
    Delay1TCY();
    ADCON0bits.GO = 1;      //A/D START
    while(ADCON0bits.GO);
    addata.adb[0] = ADRESL;
    addata.adb[1] = ADRESH;
    return addata.adw;
}

//////// A/Dʂۑ
void ad_reserve(void){
    uchar i, j;
    uint buff;
    
    for(i = 0; i < 3; i++){
        buff = 0;
        for(j = 0; j < 16; j++){    //PU̕
            buff += ad_conv(i);
            delay_ms(3);
        }
        buff += 8;                  //ľܓ
        ad_result[i] = buff >> 4;
    }
}
