//////////////////////////////////
//  ƓxL^vU  clock.c       //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

#define START_TIME 5    //JnԂ͂TŒ
uchar tim_data[7];      //f[^̕ҏWobt@ib̓_~[j
                        //N=0:b, 1:, 2:, 3:, 4:j, 5:, 6:N

//////// QabcoCi[
//       Fϊf[^A߂lFϊ
uchar bcd2hex(uchar n){
    uchar ret;
    ret = n / 16;
    ret = ret * 10;
    ret = ret + n % 16;
    return(ret);
}

//////// oCi[QabcɁil`wXXj
//       Fϊf[^A߂lFϊ
uchar hex2bcd(uchar n){
    uchar ret;
    ret = n / 10;
    ret = ret * 16;
    ret = ret + n % 10;
    return(ret);
}

///////// Q̐tɕ\
//        F\f[^
void dig_dsp2(uchar n){
    uchar n1, n2;
    n1 = n / 10;            //10̈
    n2 = n % 10;            //1̈
    lcd_data(n1 + 0x30);    //Pڕ\
    lcd_data(n2 + 0x30);    //Qڕ\
}

//////// Rg[WX^Q̓ǂݎ
uchar read_ctl2(void){
    uchar c;

    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(1);         //AhX]
    I2startRep();       //qd`cɐ؂芷
    I2write(0xa3);      //foCXZNg(READ)
    c = I2read(1);      //ްŏI
    I2stop();           //hQbI
    return c;
}

//////// Rg[WX^Q̏
//       F݃f[^
void write_ctl2(uchar c){
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(1);         //AhX]
    I2write(c);         //݃f[^
    I2stop();           //hQbI
}

//////// f[^̓ǂݎ
void read_time(void){
    uchar i;

    I2startCon();                   //hQbJn
    I2write(0xa2);                  //foCXZNg(WRITE)
    I2write(0x02);                  //AhX]
    I2startRep();                   //qd`cɐ؂芷
    I2write(0xa3);                  //foCXZNg(READ)
    for(i = 0; i < 6; i++){
        tim_data[i] = I2read(0);    //ްŏIȊO
    }
    tim_data[6] = I2read(1);        //ްŏI
    I2stop();                       //hQbI
    tim_data[0] &= 0x7f;            //S~
    tim_data[1] &= 0x7f;
    tim_data[2] &= 0x3f;
    tim_data[3] &= 0x3f;
    tim_data[4] &= 0x07;
    tim_data[5] &= 0x1f;            //tim_data[6]̓S~
}

//////// j̕\
//       FjR[h
void    show_weekdays(uchar n){
    switch(n){
        case    0:  lcd_str_rom("SUN");    break;
        case    1:  lcd_str_rom("MON");    break;
        case    2:  lcd_str_rom("TUE");    break;
        case    3:  lcd_str_rom("WED");    break;
        case    4:  lcd_str_rom("THU");    break;
        case    5:  lcd_str_rom("FRI");    break;
        case    6:  lcd_str_rom("SAT");    break;
        default:    break;
    }
}

//////// J_[̕\
void    time_dsp(void){
    read_time();
    lcd_cmd(0x80);
    lcd_str_rom("20");                      //̏
    dig_dsp2(bcd2hex(tim_data[6]));         //̉񌅂oCiϊĕ\
    lcd_data('/');
    dig_dsp2(bcd2hex(tim_data[5]));         //
    lcd_data('/');
    dig_dsp2(bcd2hex(tim_data[3]));         //
    lcd_data(' ');
    show_weekdays(bcd2hex(tim_data[4]));    //j
    lcd_cmd(0xc0);
    dig_dsp2(bcd2hex(tim_data[2]));         //
    lcd_data(':');
    dig_dsp2(bcd2hex(tim_data[1]));         //
}

///////// f[^̓͋yѕύX
//            DS:\ʒu, MIN:ŏl, MAX:ől, N:f[^ԍ
//        N = 1:, 2:, 3:, 5:, 6:N
void    data_edit(uchar DS, uchar MIN, uchar MAX, uchar N){
    uchar buf;                              //f[^pobt@
    uchar scan_down = 0;                    //XLJE^ DOWN
    uchar scan_up = 0;                      //XLJE^ UP

    buf = bcd2hex(tim_data[N]);             //f[^ BCD
    if(buf != 0 && buf < MIN) buf = MIN;    //f[^`FbN
    if(buf == 0) buf = MIN;
    if(buf > MAX) buf = MAX;
    lcd_cmd(DS);                            //\ʒu
    dig_dsp2(buf);                          //l\
    while(ENT || MODE);                     //L[OFF܂ő҂
    timer_start(TIMER_TIME_SET, 60000);     //^CAbv^C}[
    while(1){
        if(DOWN){                           //DOWNL[ꂽ
            if(buf > MIN) buf--;            //f[^ŏl傫
            lcd_cmd(DS);                    //\ʒu
            dig_dsp2(buf);                  //l\
            if(scan_down < 255) scan_down++;
            if(scan_down < 5) delay_ms(800);//ODWbXL
            else delay_ms(80);              //ODOWbXL
        }
        else scan_down = 0;                 //DOWNL[ȂXLJE^NA
        if(UP){                             //UPL[ꂽ
            if(buf < MAX) buf++;            //f[^ől菬
            lcd_cmd(DS);                    //\ʒu
            dig_dsp2(buf);                  //l\
            if(scan_up < 255) scan_up++;
            if(scan_up < 5) delay_ms(800);  //ODWbXL
            else delay_ms(80);              //ODOWbXL
        }
        else scan_up = 0;                   //UPL[ȂXLJE^NA
        if(ENT){                            //
            tim_data[N] = hex2bcd(buf);     //abcϊăobt@
            timer_cancel(TIMER_TIME_SET);
            return;
        }
       if(timer_check(TIMER_TIME_SET)) return;
    }
}

//////// N̐ݒ
void set_years(void){
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("ڷ");
    lcd_cmd(0xc0);
    lcd_str_rom("20");
    data_edit(0xc2,0,99,6);
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x08);          //AhX]
    I2write(tim_data[6]);   //f[^̏
    I2stop();
}

//////// ̐ݒ
void set_months(void){
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("·");
    data_edit(0xc0,1,12,5);
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x07);          //AhX]
    I2write(tim_data[5]);   //f[^̏
    I2stop();               //hQbI
}

//////// j̐ݒ
void set_weekdays(void){
    uchar buf;              //f[^pobt@

    buf = tim_data[4];
    if(buf > 6) buf = 6;
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("ֳ");
    lcd_cmd(0xc0);                      //\ʒu
    show_weekdays(buf);                 //j\
    while(ENT || MODE);                 //L[OFF܂ő҂
    timer_start(TIMER_WEEK_SET, 60000); //^CAbvp
    while(1){
        if(DOWN){                       //downL[ꂽ
            if(buf > 0) buf--;          //f[^ŏl傫
            else buf = 6;
            lcd_cmd(0xc0);              //\ʒu
            show_weekdays(buf);         //j\
            delay_ms(800);              //ODWbXL
        }
        if(UP){                         //UPL[ꂽ
            buf++;
            if(buf > 6) buf = 0;        //f[^őlȏɂȂ
            lcd_cmd(0xc0);              //\ʒu
            show_weekdays(buf);         //j\
            delay_ms(800);              //ODWbXL
        }
        if(ENT){                        //݃L[
            tim_data[4] = buf;          //obt@
            timer_cancel(TIMER_WEEK_SET);
            break;
        }
        if(timer_check(TIMER_WEEK_SET))break;
    }
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x06);          //AhX]
    I2write(tim_data[4]);   //f[^̏
    I2stop();               //hQbI
}

//////// ̐ݒ
void set_days(void){
    uchar max, temp1, temp2, temp3;

    max = 28;                       //̍ő̓(28-31)
    temp1 = bcd2hex(tim_data[5]);   //f[^oCi[ϊ
    temp2 = bcd2hex(tim_data[6]);   //Nf[^oCi[ϊ
    switch(temp1){                  //̍ő̐ݒ
        case    1:  max=31;     break;
        case    3:  max=31;     break;
        case    4:  max=30;     break;
        case    5:  max=31;     break;
        case    6:  max=30;     break;
        case    7:  max=31;     break;
        case    8:  max=31;     break;
        case    9:  max=30;     break;
        case    10: max=31;     break;
        case    11: max=30;     break;
        case    12: max=31;     break;
        case    2:  if(temp2 % 4 == 0) max = 29;    break;
        default:    break;
    }
    lcd_clear();
    lcd_cmd(0x80);
    lcd_data('');
    data_edit(0xc0,1,max,3);    //f[^ύX
    I2startCon();               //hQbJn
    I2write(0xa2);              //foCXZNg(WRITE)
    I2write(0x05);              //AhX]
    I2write(tim_data[3]);       //f[^̏
    I2stop();                   //hQbI
}

//////// Ԃ̐ݒ
void set_hours(void){
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("޶");
    data_edit(0xc0,0,23,2);
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x04);          //AhX]
    I2write(tim_data[2]);   //f[^̏
    I2stop();
}

//////// ̐ݒ
void set_minutes(void){
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("");
    data_edit(0xc0,0,59,1);
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x03);          //AhX]
    I2write(tim_data[1]);   //f[^̏
    I2stop();
}

//////// b̐ݒiO݁j
void set_seconds(void){
    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x02);          //AhX]
    I2write(0);             //f[^̏
    I2stop();
}

//////// ̐ݒ
void time_set(void){
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("޶  ݺ");
    delay_ms(2000);
    lcd_clear();
    lcd_cmd(0xc0);
    while(ENT);         //L[̃It҂
    read_time();        //f[^obt@ɓǂݍ
    I2startCon();       // hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0);         //AhX]
    I2write(0x20);      //v~
    I2stop();
    set_years();        //N̐ݒ
    set_months();       //̐ݒ
    set_days();         //̐ݒ
    set_weekdays();     //j̐ݒ
    set_hours();        //Ԃ̐ݒ
    set_minutes();      //̐ݒ
    set_seconds();      //b̐ݒi_~[j
    I2startCon();       // hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0);         //AhX]
    I2write(0);         //vN
    I2stop();
}

/////// A[iJnԁj̃Zbg
void alm_set(void){
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0x09);      //AhX]
    I2write(0);         //A[̏
    I2write(START_TIME);//A[̏
    I2write(0x80);      //A[̏
    I2write(0x80);      //A[T̏
    I2stop();
}

/////// A[A荞݊Jn
void alm_start(void){
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0xf);       //AhX]
    I2write(1);         //荞݃JEgl
    I2stop();           //hQbI
    Nop();
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(1);         //AhX]
    I2write(0x13);      //Rg[WX^
    I2stop();           //hQbI
    Nop();
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0xe);       //AhX]
    I2write(0x83);      //^C}[Rg[WX^
    I2stop();           //hQbI
}

/////// A[A荞ݒ~
void alm_stop(void){
    Nop();
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0xe);       //AhX]
    I2write(0);         //^C}[Rg[WX^
    I2stop();           //hQbI
    Nop();
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(1);         //AhX]
    I2write(0);         //Rg[WX^
    I2stop();           //hQbI
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0xf);       //AhX]
    I2write(0);         //荞݃JEgl
    I2stop();           //hQbI
}

//////// v̏ݒ
void    tim_init(void){
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0);         //AhX]
    I2write(0);         //f[^̏(Rg[WX^Pj
    I2write(0);         //f[^̏(Rg[WX^Qj
    I2stop();           //hQbI
    delay_ms(1);
    I2startCon();       //hQbJn
    I2write(0xa2);      //foCXZNg(WRITE)
    I2write(0x0d);      //AhX]
    I2write(0);         //f[^̏(NbNo͋֎~j
    I2stop();           //hQbI
}

//////// obNAbv̓dቺ̌o
void vlchk(void){
    int temp;

    I2startCon();           //hQbJn
    I2write(0xa2);          //foCXZNg(WRITE)
    I2write(0x02);          //AhX]
    I2startRep();           //qd`cɐ؂芷
    I2write(0xa3);          //foCXZNg(READ)
    temp = I2read(1);       //AhXQǂݍ
    I2stop();               //hQbI
    if(temp & 0x80){        //dቺ
        I2startCon();       //hQbJn
        I2write(0xa2);      //foCXZNg(WRITE)
        I2write(0x09);      //AhX]
        I2write(0x80);      //A[NAij
        I2write(0x80);      //A[NAij
        I2write(0x80);      //A[NAij
        I2write(0x80);      //A[NAiTj
        I2stop();           //hQbI
        lcd_clear();
        lcd_cmd(0x80);
        lcd_str_rom("Ĺ X");
        lcd_cmd(0xc0);
        lcd_str_rom("PUSH ENT");
        while(!ENT);        //ENTL[҂
        time_set();         //f[^Zbg
    }
}
