//////////////////////////////////
//  ƓxL^vU  measure.c     //
//  2015/01/23   PIC18F2523     //
//  MPLAB v8.63   C18 v3.37.01  //
//////////////////////////////////
#include "global.h"

uchar date_buff[6]; //vJnԂ̓ǂݎobt@
                    //0:A1:A2:A3:TA4:A5:N

/////// Ɠx\
//      F`l
void lcd_lux(uint lx_data){
    uint lux;
    uchar n1,n2,n3,n4,n5;

    lux = 5 * lx_data;
    n1 = lux/10000;
    lux = lux%10000;
    n2 = lux/1000;
    lux = lux%1000;
    n3 = lux/100;
    lux = lux%100;
    n4 = lux/10;
    n5 = lux%10;
    if(n1) lcd_data(n1 + 0x30);
    else lcd_data(' ');
    if(n1 || n2) lcd_data(n2 + 0x30);
    else lcd_data(' ');
    if(n1 || n2 || n3) lcd_data(n3 + 0x30);
    else lcd_data(' ');
    if(n1 || n2 || n3 || n4) lcd_data(n4 + 0x30);
    else lcd_data(' ');
    if(n1 || n2 || n3 || n4 || n5) lcd_data(n5 + 0x30);
    else lcd_data(' ');
    lcd_str_rom("0LUX");
}

/////// drd\
void lcd_vb(void){
    uint buff;
    uchar n1,n2,n3;

    lcd_cmd(0xcd);
    buff = ad_result[2];
    buff += 5;          //ľܓ̈
    n1 = buff/1000;
    buff = buff%1000;
    n2 = buff/100;
    buff = buff%100;
    n3 = buff/10;
    lcd_data(n1 + 0x30);
    lcd_data('.');
    lcd_data(n2 + 0x30);
    lcd_data(n3 + 0x30);
    lcd_data('V');
}

//////// v\
void measure(void){
    uchar mn;

    mn = 0;
    timer_start(TIMER_MEASURE,60000);           //P^C}[
    lcd_clear();
    while(1){
        ad_reserve();                           //ADlۑ
        time_dsp();                             //J_[ǂݎ\
        lcd_vb();                               //drd\
        lcd_cmd(0x94);
        lcd_str_rom("CH1:  ");
        lcd_lux(ad_result[0]);                  //CH1Ɠx\
        lcd_cmd(0xd4);
        lcd_str_rom("CH2:  ");
        lcd_lux(ad_result[1]);                  //CH2Ɠx\
        if(MODE) break;
        if(timer_check_start(TIMER_MEASURE)){
            mn++;
            if(mn > 2) break;                   //RŏI
        }
    }
    timer_cancel(TIMER_MEASURE);
}

//////// v̕\
//       F vʒuA݁Fwr = 0;AǂݏoFwr = 1
void lcd_num(uint nn, uchar wr){
    uchar n1,n2,n3;

    lcd_cmd(0xc7);
    nn += 1;
    n1 = nn/100;
    nn = nn%100;
    n2 = nn/10;
    n3 = nn%10;
    if(wr) lcd_data('R');
    else lcd_data('W');
    lcd_data(n1 + 0x30);
    lcd_data(n2 + 0x30);
    lcd_data(n3 + 0x30);
}

//////// L^̕\
void    rom_date(void){
    lcd_cmd(0x80);
    lcd_str_rom("20");                       //̏
    dig_dsp2(bcd2hex(date_buff[5]));         //̉񌅂oCiϊĕ\
    lcd_data('/');
    dig_dsp2(bcd2hex(date_buff[4]));         //
    lcd_data('/');
    dig_dsp2(bcd2hex(date_buff[2]));         //
    lcd_data(' ');
    show_weekdays(bcd2hex(date_buff[3]));    //j
 }

//////// Jn̏
void write_start_time(void){
    uint i, addr;

    IntI2c = 0;
    addr = 0x1000;
    read_time();                    //vǂݍ
    I2startCon();                   //hQbJn
    I2write(0xae);                  //foCXZNg(WRITE)
    I2write(addr >> 8);             //AhXʏ
    I2write(addr);                  //
    for(i = 1; i < 7; i++){
        I2write(tim_data[i]);       //vf[^
    }
    I2stop();                       //hQbI
}

//////// PvROM
//       Fv
void write_rom(uint num){
    uint addr;
    
    IntI2c = 0;
    addr = num * 4;
    I2startCon();               //X^[gRfBV
    I2write(0xae);              //foCXZNg
    I2write(addr >> 8);         //AhXʏ
    I2write(addr);              //
    I2write(ad_result[0] >> 8); //CH1
    I2write(ad_result[0]);      //CH1
    I2write(ad_result[1] >> 8); //CH2
    I2write(ad_result[1]);      //CH2
    I2stop();                   //XgbvV[PX
    delay_ms(10);
}

//////// MO
void sampling(void){
    int i;
    uchar c;
    
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("   Ͻ?");
    lcd_cmd(0xc0);
    lcd_str_rom("Y = ENT");
    while(ENT);
    timer_start(TIMER_SAMP_OFF, 60000);
    while(1){
        if(ENT) break;
        if(MODE){
            while(MODE);
            timer_cancel(TIMER_SAMP_OFF);
            return;
        }
        if(timer_check(TIMER_SAMP_OFF))return;   //^CAbv
    }
    while(ENT);
    lcd_clear();
    INTCONbits.INT0IE = 1;          //INT0荞ݗL
    INTCON2bits.INTEDG0 = 0;        //
    alm_set();                      //JnԂ̃Zbg
    alm_start();                    //A[A荞݊Jn
    lcd_cmd(0xc7);
    lcd_str_rom("WAIT");
    while(1){
        poff_cnt = 0;                       //^CAbvȂ
        if((c = read_ctl2()) & 0x8){
            c &= 0xf7;                      //A[tONA
            write_ctl2(c);
            break;
       }
        ad_reserve();                       //ADlۑ
        time_dsp();                         //J_[ǂݎ\
        lcd_vb();                           //drd\
        lcd_cmd(0x94);
        lcd_str_rom("CH1:  ");
        lcd_lux(ad_result[0]);              //CH1Ɠx\
        lcd_cmd(0xd4);
        lcd_str_rom("CH2:  ");
        lcd_lux(ad_result[1]);              //CH2Ɠx\
        if(!PORTCbits.RC2 && !PORTCbits.RC5){           //I
            lcd_clear();
            while(!PORTCbits.RC2 || !PORTCbits.RC5);    //L[It҂
            alm_stop();                                 //A[A荞ݒ~
            return;
        }
        Sleep();
        Nop();
    }
    time_dsp();                     //J_[ǂݎ\
    write_start_time();             //JnL^
    i = 0;
    while(1){
        poff_cnt = 0;               //^CAbvȂ
        ad_reserve();               //ADlۑ
        write_rom(i);               //ROM
        time_dsp();                 //J_[ǂݎ\
        lcd_vb();                   //drd\
        lcd_cmd(0x94);
        lcd_str_rom("CH1:  ");
        lcd_lux(ad_result[0]);      //CH1Ɠx\
        lcd_cmd(0xd4);
        lcd_str_rom("CH2:  ");
        lcd_lux(ad_result[1]);      //CH2Ɠx\
        lcd_num(i, 0);                                  //v\
        if(!PORTCbits.RC2 && !PORTCbits.RC5){           //I
            lcd_clear();
            while(!PORTCbits.RC2 || !PORTCbits.RC5);    //L[It҂
            alm_stop();                                 //A[A荞ݒ~
            return;
        }
        i++;
        if(i >= 840) LATAbits.LATA7 = 0;        //dՒf
        Sleep();
        Nop();
    }
}

//////// Jn̓ǂݎ(ROM)
void read_start_time(void){
    uint i, addr;

    IntI2c = 0;    
    addr = 0x1000;
    I2startCon();                   //hQbJn
    I2write(0xae);                  //foCXZNg(WRITE)
    I2write(addr >> 8);             //AhXʏ
    I2write(addr);                  //
    I2startRep();                   //qd`cɐ؂芷
    I2write(0xaf);                  //foCXZNg(READ)
    for(i = 0; i < 5; i++){
        date_buff[i] = I2read(0);   //ްŏIȊO
    }
    date_buff[5] = I2read(1);       //ްŏI
    I2stop();                       //hQbI
}

//////// v̕\
//       F̏lijAv
void time_reconst(uint t_start, uint nn){
    uint buff, hh, mm;
    uchar n1, n2, n3, n4;

    buff = t_start + nn;
    hh = buff / 60;
    mm = buff % 60;
    n1 = hh / 10;
    n2 = hh % 10;
    n3 = mm / 10;
    n4 = mm % 10;
    lcd_cmd(0xc0);
    lcd_data(n1 + 0x30);
    lcd_data(n2 + 0x30);
    lcd_data(':');
    lcd_data(n3 + 0x30);
    lcd_data(n4 + 0x30);
}

//////// P񕪂̂qnlf[^ǂݏo
//       Fv񐔈ʒu
void rom_read(uint num){
    uint addr,i;
    uint buff[4];

    IntI2c = 0;                         //荞݃tOiRs[jNA
    addr = num * 4;                     //ǂݏoAhX
    I2startCon();                       //X^[gRfBV
    I2write(0xae);                      //foCXZNgiCgj
    I2write(addr >> 8);                 //AhXʏ
    I2write(addr);                      //
    I2startRep();                       //X^[gđ
    I2write(0xaf);                      //foCXZNgi[hj
    for(i = 0; i < 3; i++){             //vlǂݎ
        buff[i] = I2read(0);
    }
    buff[3] = I2read(1);
    I2stop();
    lcd_num(num, 1);                    //vʒu\
    lcd_cmd(0x94);
    lcd_str_rom("CH1:  ");
    lcd_lux((buff[0] << 8) + buff[1]);  //CH1Ɠx\
    lcd_cmd(0xd4);
    lcd_str_rom("CH2:  ");
    lcd_lux((buff[2] << 8) + buff[3]);  //CH2Ɠx\
}

//////// f[^̓ǂݏo\
void data_read(void){
    uint m_count;       //\ԁij
    uint n_count;       //v񐔁ij
    uint n_start;       //X^[ǧoߎԁij

    lcd_clear();
    read_start_time();  //vJnROMǂ
    rom_date();         //vJn̕\
    n_count = 0;
    m_count = 0;
    n_start = bcd2hex(date_buff[1]);
    n_start *= 60;
    n_start += bcd2hex(date_buff[0]);           //vJnԁiZj
    rom_read(n_count);                          //vlǂݏo\
    time_reconst(n_start, n_count);             //vԂ𕜌\
    timer_start(TIMER_ROM_READ,60000);          //I^C}[
    while(1){
        if(DOWN){                               //downL[ꂽ
            m_count = 0;
            if(n_count > 0) n_count--;
            rom_read(n_count);                  //f[^\
            time_reconst(n_start, n_count);     //vԂ𕜌\
            if(DOWN_L)delay_ms(60);             //
            else delay_ms(600);                 //ODUbXL
        }
        if(UP){                                 //UPL[ꂽ
            m_count = 0;
            if(n_count < 839) n_count++ ;
            rom_read(n_count);                  //f[^\
            time_reconst(n_start, n_count);     //vԂ𕜌\
            if(UP_L)delay_ms(60);               //
            else delay_ms(600);                 //ODUbXL
        }
        if(MODE){                               //LZ
            while(MODE);
            return;
        }
        if(timer_check_start(TIMER_ROM_READ)) m_count++;
        if(m_count > 5){
            timer_cancel(TIMER_ROM_READ);
            return;
        }
    }
}

//////// f[^̏iO݁j
void removal(void){
    uint i, addr;
    
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("   Y / N");
    while(ENT);
    lcd_cmd(0xc0);
    lcd_str_rom(" Y=ENT");
    timer_start(TIMER_REMOVAL, 20000);      //^CAbv^C}[
    while(1){
        if(ENT_L)break;
        if(DOWN || UP || MODE){
            while(DOWN || UP || MODE);
            timer_cancel(TIMER_REMOVAL);
            return;
        }
        if(timer_check(TIMER_REMOVAL))return;
    }
    ad_result[0] = 0;
    ad_result[1] = 0;
    lcd_clear();
    lcd_cmd(0x80);
    lcd_str_rom("");
    for(i = 0;i < 840;i++){     //Ɠxf[^̏
        write_rom(i);
    }
    IntI2c = 0;
    addr = 0x1000;              //JnԂ̏
    I2startCon();               //X^[gRfBV
    I2write(0xae);              //foCXZNg
    I2write(addr >> 8);         //AhXʏ
    I2write(addr);              //
    for(i = 0; i < 7; i++){
        I2write(0);
    }
    I2stop();                   //XgbvV[PX
    delay_ms(10);
}
